"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BYTE_LENGTH = void 0;
exports.base64UrlEncode = base64UrlEncode;
exports.generateChallenge = generateChallenge;

var _cryptoJs = _interopRequireDefault(require("crypto-js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const BYTE_LENGTH = 96;
exports.BYTE_LENGTH = BYTE_LENGTH;

function base64UrlEncode(str) {
  return str.replace(/\+/g, '-').replace(/\//g, '_').replace(/=/g, '');
}

function generateChallenge(verifier) {
  const hash = _cryptoJs.default.SHA256(verifier).toString(_cryptoJs.default.enc.Base64);

  return base64UrlEncode(hash);
}
//# sourceMappingURL=utils.js.map