// @ts-ignore
import { NativeModules } from 'react-native';
import CryptoJS from 'crypto-js';
import { BYTE_LENGTH } from './utils';
export default function generateRandomBytes() {
  if (NativeModules.ExpoRandom) {
    const bytes = NativeModules.ExpoRandom.getRandomBase64String(BYTE_LENGTH);
    return bytes;
  }

  if (global.ExpoModules) {
    const bytes = global.ExpoModules.ExpoRandom.getRandomBase64String(BYTE_LENGTH);
    return bytes;
  }

  if (global.RNPkceChallenge) {
    const bytes = global.RNPkceChallenge.randomBytes();
    return bytes;
  }

  const buffer = CryptoJS.lib.WordArray.random(BYTE_LENGTH);
  const bytes = buffer.toString(CryptoJS.enc.Base64);
  return bytes;
}
//# sourceMappingURL=generate-random-bytes.native.js.map